//
//  ProjectItem.m
//  DG
//
//  Created by Mark Brindle on 11/07/2011.
//  Copyright 2011 ARKEMM Software Limited. All rights reserved.
//

#import "ProjectItem.h"
#import "Timecard.h"

@implementation ProjectItem

- (id)init
{
    self = [super init];
    if (self) {
        // Initialization code here.
    }
    
    return self;
}

- (double)totalCost {
  double total = 0.0;
  for (Timecard *tc in [self timecards]) {
    total += [tc cost];
  }
  return total;
}

-(int)timecardCount {
  return [[self timecards] count];
}

- (double)updateTotalTime {
  // Amalgamate the time for each timecard.
  double total = 0.0;
  for (Timecard *tc in [self timecards]) {
    total += [[tc dateEnded] timeIntervalSinceDate:[tc dateStarted]];
  }
  return total;
}

- (Timecard *)currentTimecard {
  // The most recent timecard will be the first sortedTimecards entry.
  // If we have a timecard currently being recorded return it, otherwise nil.
  Timecard *card = [[self sortedTimecards] objectAtIndex:0];
  if ([card dateEnded] == nil) {
    return card;
  }
  return nil;
}

- (NSArray *)sortedTimecards {
  NSSortDescriptor *alpha = [[NSSortDescriptor alloc] 
                             initWithKey:@"dateStarted" ascending:NO];
  NSArray *descriptors = [NSArray arrayWithObject:alpha];
  alpha = nil;
  return [[[self timecards] allObjects] sortedArrayUsingDescriptors:descriptors];
}


@end
